package parsing;
import java.util.Vector;

public class SymTab
{

 private final int ensureCapacity = 5;

 private int NEntry = -1;

 public static SymTab ST;
 public String[] table;
 public char[] stype;

 /**
 * constructor
 */
 public SymTab()
 {
  ST = this;
  table = new String[100];
  stype = new char[table.length];
  for(int i = 0; i<stype.length; i++)
  {
   table[i] = new String();
   stype[i] = ' ';
  }
 }

 public SymTab(String[] objs)
 {
  ST = this;
  table = objs;
  NEntry = table.length-1;
 }

 public final void addEntry(String s, char t)
 {
  if(lookup(s)!=-1) throw new ParsingException("Duplicate variable name: "+s);
  else
  {
   if(NEntry==table.length-1)
   {
    String[] temp = table;
    table = new String[NEntry+ensureCapacity];
    System.arraycopy(temp, 0, table, 0, temp.length);
    temp = null;
    System.gc();
   }
   table[++NEntry] = s;
   stype[NEntry] = t;
  }
 }

 public final int lookup(String element)
 {
  int i = table.length - 1;
  while(i>=0)
  {
   if(strcmp(element, table[i])) break;
   i--;
  }
  return i;
 }

 private final boolean strcmp(String s1, String s2)
 {
  if(s1.length()!=s2.length()) return false;
  int i = s1.length()-1;
  while(i>=0)
  {
   if(s1.charAt(i)!=s2.charAt(i--)) break;
   return true;
  }
  return false;
 }

 public String[] getDefined()
 {
  Vector v = new Vector();
  String[] s;
  int i = table.length-1;
  while(i>=0)
  {
   if(ctype[i]!=' ') v.addElement(table[i]);
  }
  v.copyInto(s);
  v = null;
  return s;
 }
}

