package parsing.nonterminals;
import parsing.Parser;

public class Block extends NonTerminal
{

 /**
 * constructor
 */
 public Block(Parser parser)
 {
  super(parser);
 }

 public void parse()
 {
  char c;
  parser.scan();
  while(!inArray((c=parser.getToken()), new char[]{'e', 'l'}))
  {
   switch(c)
   {
    case 'i':
     new DoIf(parser).parse();
     break;
    case 'w':
     new DoWhile(parser).parse();
     break;
    case 'R':
     new DoRead(parser).parse();
     break;
    case 'W':
     new DoWrite(parser).parse();
     break;
    default:
     new Assignment(parser).parse();
     break;
   }
   parser.scan();
  }
 }
}



