package parsing.nonterminals;
import parsing.Parser;
import codegen.CodeGen;

public class Decl extends NonTerminal
{

 /**
 * constructor
 */
 public Decl(Parser parser)
 {
  super(parser);
 }

 public void parse()
 {
  String s;
  if(inTable(s = getName())) parser.abort("Duplicate variable name: "+s);
  else
  {
   CodeGen.alloc(s);
   identifiers.addEntry(s, 'v');
  }
  while(parser.getLook()==',')
  {
   parser.match(',');
   if(inTable(s=getName())) parser.abort("Duplicate variable name: "+s);
   else
   {
    CodeGen.alloc(s);
    identifiers.addEntry(s, 'v');
   }
  }
 }
}




