package parsing.nonterminals;
import parsing.Parser;
import codegen.CodeGen;

public class DoWhile extends NonTerminal
{

 /**
 * constructor
 */
 public DoWhile(Parser parser)
 {
  super(parser);
 }

 public void parse()
 {
  Label label1 = new Label(parser);
  Label label2 = new Label(parser);
  label1.printLabel();
  new BoolExpression(parser).parse();
  CodeGen.branchFalse(label2.getName());
  new Block(parser).parse();
  CodeGen.branch(label1.getName());
  label2.printLabel();
  parser.matchString("ENDWHILE");
 }
}

