package parsing.nonterminals;
import codegen.CodeGen;
import parsing.Parser;

public class Main extends NonTerminal
{

 /**
 * constructor
 */
 public Main(Parser parser)
 {
  super(parser);
 }

 public void parse()
 {
  parser.matchString("BEGIN");
  CodeGen.openMethod();
  new Block(parser).parse();
  parser.matchString("END");
  CodeGen.destroyApp();
  CodeGen.closeMethod();
 }
}



