package parsing.nonterminals;
import codegen.CodeGen;
import parsing.Parser;

public class Program extends NonTerminal
{

 /**
 * constructor
 */
 public Program(Parser parser)
 {
  super(parser);
  CodeGen codegen = new CodeGen(parser);
 }

 public void parse()
 {
  parser.matchString("PROGRAM");
  CodeGen.createTemplate();
  new TopDecls(parser).parse();
  new Main(parser).parse();
  parser.match('.');
 }
}

