package parsing.nonterminals;
import parsing.Parser;

public class TopDecls extends NonTerminal
{

 /**
 * constructor
 */
 public TopDecls(Parser parser)
 {
  super(parser);
 }

 public void parse()
 {
  char m;
  parser.scan();
  while((m=parser.getToken())!='b')
  {
   switch(m)
   {
    case 'v':
     new Decl(parser).parse();
     break;
    default:
     parser.abort("Unrekognized keyword "+parser.getValue());
     break;
   }
   parser.scan();
  }
 }
}
