package parsing.nonterminals;
import parsing.Parser;
import codegen.CodeGen;

public class BoolTerm extends NonTerminal
{

 private NotFactor notfactor;

 /**
 * constructor
 */
 public BoolTerm(Parser parser)
 {
  super(parser);
  notfactor = new NotFactor(parser);
 }

 public void parse()
 {
  notfactor.parse();
  while(parser.getLook()=='&')
  {
   parser.match('&');
   notfactor.parse();
   CodeGen.popAnd();
  }
 }
}

