package parsing.nonterminals;
import parsing.Parser;
import codegen.CodeGen;

public class DoIf extends NonTerminal
{

 private Block block;

 /**
 * constructor
 */
 public DoIf(Parser parser)
 {
  super(parser);
  block = new Block(parser);
 }

 public void parse()
 {
  Label label1 = new Label(parser);
  Label label2 = label1;
  new BoolExpression(parser).parse();
  CodeGen.branchFalse(label2.getName());
  block.parse();
  if(parser.getToken()=='l')
  {
   label2 = new Label(parser);
   CodeGen.branch(label2.getName());
   label1.printLabel();
   block.parse();
   CodeGen.branch(label2.getName());
  }
  label2.printLabel();
  parser.matchString("ENDIF");
 }
}

