package parsing.nonterminals;
import parsing.Parser;
import codegen.CodeGen;

public class DoWrite extends NonTerminal
{

 private Expression expr;

 /**
 * constructor
 */
 public DoWrite(Parser parser)
 {
  super(parser);
  expr = new Expression(parser);
 }

 public void parse()
 {
  parser.match('(');
  expr.parse();
  CodeGen.write();
  while(parser.getLook()==',')
  {
   expr.parse();
   CodeGen.write();
  }
  parser.match(')');
 }
}
