package parsing.nonterminals;
import parsing.Parser;
import codegen.CodeGen;

public class Factor extends NonTerminal
{

 /**
 * constructor
 */
 public Factor(Parser parser)
 {
  super(parser);
 }

 public void parse()
 {
  if(parser.isAlpha(parser.getLook()))
  {
    CodeGen.loadVar(getName());
  }
  else if(parser.getLook()=='(')
  {
   parser.match('(');
   new BoolExpression(parser).parse();
   parser.match(')');
  }else
  {
   CodeGen.loadConst(getNum());
  }
 }
}

