package parsing.nonterminals;
import parsing.Parser;
import codegen.CodeGen;

public class NotFactor extends NonTerminal
{

 private Relation relation;

 /**
 * constructor
 */
 public NotFactor(Parser parser)
 {
  super(parser);
  relation = new Relation(parser);
 }

 public void parse()
 {
  if(parser.getLook()=='!')
  {
   relation.parse();
   CodeGen.notIt();
  }
  else
  {
   relation.parse();
  }
 }
}
